package jpatp.lazy;

import java.util.ArrayList;
import java.util.Collection;
//import java.util.List;

//import javax.persistence.Query;
import javax.persistence.EntityManager;
import jpa.test.client.*;

/**
 * 
 * @author Tomo, Nagasawa
 * 
 */
public class Client extends ClientJPABase
{

    //private Query query;

    public static void main(String args[])
    {
        Client cl = new Client("em1");
        cl.lazy001();
    }

    // RXgN^
    private Client(String unitname)
    {
        super(unitname);
    }

    /**
     * CLID001
     * 
     * @return
     */

    public boolean lazy001()
    {
        testStart("lazy001");
        try
        {
            EntityManager em = getEntityManager();

            // TP log starts
            // transaction starts
            transactionBegin();
            Job a = new Job(1, "aaa", 1);
            Collection<Employee> en = new ArrayList<Employee>();

            en.add(new Employee(1, "NAGA", 1));
            en.add(new Employee(2, "NAGA", 1));
            a.setEmployees(en);
            em.persist(a);

            a = new Job(2, "aaa", 1);
            Collection<Employee> en1 = new ArrayList<Employee>();
            en1.add(new Employee(3, "NAGA", 1));
            en1.add(new Employee(4, "NAGA", 1));
            a.setEmployees(en1);
            em.persist(a);

            transactionCommit();
            cleanup();
            em = getEntityManager();
            transactionBegin();

            Job emp = em.find(Job.class, 1);
            cleanup();

            System.out.println("## JOB_ID = " + emp.getJobid() + " JOB_Name = " + emp.getJobname());
            log("## JOB_ID = " + emp.getJobid() + " JOB_Name = " + emp.getJobname());
            detail("## JOB_ID = " + emp.getJobid() + " JOB_Name = " + emp.getJobname());
            for(Employee employee8 : emp.getEmployees())
            {
                System.out.println("ID = " + employee8.getId() + " Name = " + employee8.getName());
                log("ID = " + employee8.getId() + " Name = " + employee8.getName());
                detail("ID = " + employee8.getId() + " Name = " + employee8.getName());
            }

        }

        catch(Throwable th)
        {
            detail("Unexpected exception occured.");
            detail(th.getMessage());
            th.printStackTrace();
            failed("Unexpected exception occured.", th);
            transactionRollback();
        }
        finally
        {
            testEnd();
        }
        return true;
    }

}
