package jpatp.lazy;

import java.io.Serializable;
import javax.persistence.*;

import java.util.Collection;
//import java.util.List;
import java.util.ArrayList;

/**
 * @author Tomo Nagasawa
 * 
 */

@Entity
@Table(name = "JOB")
public class Job implements Serializable
{

    /**
     * 
     */
    private static final long serialVersionUID = 3700068508694044195L;

    @Id
    @Column(name = "JOB_ID")
    private int job_id;

    @Column(name = "JOB_NAME")
    private String job_name;

    @Column(name = "JOB_NUMBER")
    private int job_number;

    @ManyToMany(targetEntity = Employee.class, cascade = CascadeType.ALL, fetch = FetchType.LAZY)
    @JoinTable(name = "JOB_EMPLOYEE", joinColumns = @JoinColumn(name = "JOB_IDTABLE", referencedColumnName = "JOB_ID"), inverseJoinColumns = @JoinColumn(name = "ID_TABLE", referencedColumnName = "ID"))
    @OrderBy("")
    private Collection<Employee> employees = new ArrayList<Employee>();

    public Collection<Employee> getEmployees()
    {
        return employees;
    }

    public void setEmployees(Collection<Employee> employees)
    {

        this.employees = employees;
    }

    public Job(int JOB_ID, String JOB_NAME, int JOB_NUMBER)
    {
        this.job_id = JOB_ID;
        this.job_name = JOB_NAME;
        this.job_number = JOB_NUMBER;
    }

    public Job()
    {}

    public int getJobid()
    {
        return job_id;
    }

    public void setJobid(int JOB_ID)
    {
        this.job_id = JOB_ID;
    }

    public String getJobname()
    {
        return job_name;
    }

    public void setJobname(String JOB_NAME)
    {
        this.job_name = JOB_NAME;
    }

    public int getJobnumber()
    {
        return job_number;

    }

    public void setJobnumber(int JOB_NUMBER)
    {
        this.job_number = JOB_NUMBER;
    }

}
